/**
 *	@file	MainFrame.cpp
 *	@brief	Ct[DonutP API֌W
 *	@note
 *		+++ mainfrm.hMainFrame.cpp Aapi֌W𕪗
 */

#include "stdafx.h"

#if 1

#include "MainFrame.h"								//+++ "MainFrm.h"
#include "api.h"
#include "PluginEventImpl.h"

#else

#include "resource.h"
#include "DonutDefine.h"
#include "mtl.h"

#include "ItemIDList.h"

#include "ExMenu.h"
#include "ToolTipManager.h"
#include "DonutPFunc.h"

#include "DonutFavoritesMenu.h"
#include "DonutOptions.h"
#include "DonutSecurityZone.h"
#include "DonutSimpleEventManager.h"

// drafts
#include "DialogKiller.h"
#include "ReBarVerticalBorder.h"
#include "FileNotification.h"
#include "FlatComboBox.h"
// ENDED

#include "Donut.h"
#include "MainFrameFileDropTarget.h"
#include "DonutView.h"
#include "DonutClipboardBar.h"
#include "DonutRebarCtrl.h"
#include "FavTreeViewCtrl.h"
#include "DonutPanelBar.h"
#include "PluginBar.h"

#include "DonutExplorerBar.h"
#include "DonutLinksBarCtrl.h"
#include "DonutToolBar.h"
#include "DonutStatusBarCtrl.h"

#include "AddressBar.h"
#include "SearchBar.h"
#include "MDITabCtrl.h"

#include "FavoriteMenu.h"

#include "initguid.h"
#include "DonutP.h"
//#include "DonutP_i.c"

#include "ie_feature_control.h"
//+++ #include "FileCriticalSection.h"				//+++ ʂ̕@Ƃ̂ŁAsvɂȂ.
#include "MDIChildUserMessenger.h"
#include "dialog/aboutdlg.h"
#include "ChildFrame.h"								//+++ "ChildFrm.h"
#include "MainFrame.h"								//+++ "MainFrm.h"

#include "api.h"
//extern CMainFrame *g_pMainWnd;

#include "PluginEventImpl.h"
#endif


//public:
/////////////////////////////////////////////
// DonutP API
/////////////////////////////////////////////


IDispatch *CMainFrame::ApiGetDocumentObject(int nTabIndex)
{
	HWND		 hTabWnd = m_MDITab.GetTabHwnd(nTabIndex);
	if (hTabWnd == NULL)
		return NULL;

	CWebBrowser2 browser = DonutGetIWebBrowser2(hTabWnd);

	IDispatch *  spDocument = 0;
	browser.m_spBrowser->get_Document(&spDocument);
	return (IDispatch *) spDocument;
}


IDispatch *CMainFrame::ApiGetWindowObject(int nTabIndex)
{
	HWND					  hTabWnd = m_MDITab.GetTabHwnd(nTabIndex);
	if (hTabWnd == NULL)
		return NULL;

	CWebBrowser2			  browser = DonutGetIWebBrowser2(hTabWnd);

	CComPtr<IDispatch>		  spDisp  = 0;
	HRESULT 				  hr	  = browser.m_spBrowser->get_Document(&spDisp);
	CComQIPtr<IHTMLDocument2> spDoc   = spDisp;

	IHTMLWindow2 *			  spWnd   = 0;
	spDoc->get_parentWindow(&spWnd);
	return (IDispatch *) spWnd;
}


IDispatch *CMainFrame::ApiGetWebBrowserObject(int nTabIndex)
{
	HWND		  hTabWnd	= m_MDITab.GetTabHwnd(nTabIndex);

	if (hTabWnd == NULL)
		return NULL;

	CWebBrowser2  browser	= DonutGetIWebBrowser2(hTabWnd);

	IWebBrowser2 *spBrowser = 0;
	browser.m_spBrowser->QueryInterface(IID_IWebBrowser2, (void **) &spBrowser);
	return (IDispatch *) spBrowser;
}


long CMainFrame::ApiGetTabIndex()
{
	return m_MDITab.GetCurSel();
}


void CMainFrame::ApiSetTabIndex(int nTabIndex)
{
	m_MDITab.SetCurSelEx(nTabIndex);
}


void CMainFrame::ApiClose(int nTabIndex)
{
	HWND hTabWnd = m_MDITab.GetTabHwnd(nTabIndex);

	::SendMessage(hTabWnd, WM_COMMAND, ID_FILE_CLOSE, 0);
}


long CMainFrame::ApiGetTabCount()
{
	return m_MDITab.GetItemCount();
}


void CMainFrame::ApiMoveToTab(int nBeforIndex, int nAfterIndex)
{
	CSimpleArray<int> aryBefor;
	aryBefor.Add(nBeforIndex);
	m_MDITab.MoveItems(nAfterIndex + 1, aryBefor);
}


int CMainFrame::ApiNewWindow(BSTR bstrURL, BOOL bActive)
{
	CString 	 strURL(bstrURL);

	int 		 nCmdShow = bActive ? -1 : SW_SHOWNOACTIVATE;

	if (m_MDITab.GetItemCount() == 0)
		nCmdShow = -1;

	CChildFrame *pChild   = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);
	if (pChild == NULL)
		return -1;

	pChild->ActivateFrame(nCmdShow);

	if ( strURL.IsEmpty() )
		strURL = _T("about:blank");

	pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon
	pChild->Navigate2(strURL);
pChild->ForceMessageLoop();								//+++ ... łɕsv낤Ƃ肠c...
	return m_MDITab.GetTabIndex(pChild->m_hWnd);
}


void CMainFrame::ApiShowPanelBar()
{
	if ( m_ExplorerBar.IsPanelBarVisible() )
		return;

	SendMessage(WM_COMMAND, ID_VIEW_PANELBAR, 0);
}


long CMainFrame::ApiGetTabState(int nIndex)
{
	BYTE bytData = 0;

	if (m_MDITab.GetItemState(nIndex, bytData) == false)
		return -1;

	long nRet	 = 0;

	if (bytData & TCISTATE_SELECTED) {
		nRet = 1;
	} else if (bytData & TCISTATE_MSELECTED) {
		nRet = 2;
	}

	return nRet;
}


IDispatch *CMainFrame::ApiGetPanelWebBrowserObject()
{
	if ( !m_ExplorerBar.m_PanelBar.IsWindow() )
		m_ExplorerBar.m_PanelBar.CreatePanelBar(m_hWnd, FALSE);

	return m_ExplorerBar.m_PanelBar.GetPanelWebBrowserObject();
}


IDispatch *CMainFrame::ApiGetPanelWindowObject()
{
	if ( !m_ExplorerBar.m_PanelBar.IsWindow() )
		m_ExplorerBar.m_PanelBar.CreatePanelBar(m_hWnd, FALSE);

	return m_ExplorerBar.m_PanelBar.GetPanelWindowObject();
}


IDispatch *CMainFrame::ApiGetPanelDocumentObject()
{
	if ( !m_ExplorerBar.m_PanelBar.IsWindow() )
		m_ExplorerBar.m_PanelBar.CreatePanelBar(m_hWnd, FALSE);

	return m_ExplorerBar.m_PanelBar.GetPanelDocumentObject();
}


//IAPI2 by minit
void CMainFrame::ApiExecuteCommand(int nCommand)
{
	::SendMessage(m_hWnd, WM_COMMAND, (WPARAM) (nCommand & 0xFFFF), 0);
}


void CMainFrame::ApiGetSearchText( /*[out, retval]*/ BSTR *bstrText)
{
	CString strBuf;
	CEdit	edit = m_SearchBar.GetEditCtrl();
	int 	len  = edit.GetWindowTextLength() + 1;

	edit.GetWindowText(strBuf.GetBuffer(len), len);
	strBuf.ReleaseBuffer();
	*bstrText = CComBSTR(strBuf).Copy();
}


void CMainFrame::ApiSetSearchText(BSTR bstrText)
{
	CString strText = bstrText;
	CEdit	edit	= m_SearchBar.GetEditCtrl();

	edit.SendMessage(WM_CHAR, 'P');
	edit.SetWindowText(strText);
}


void CMainFrame::ApiGetAddressText( /*[out, retval]*/ BSTR *bstrText)
{
	CString strBuf;
	CEdit	edit = m_AddressBar.GetEditCtrl();
	int 	len  = edit.GetWindowTextLength() + 1;

	edit.GetWindowText(strBuf.GetBuffer(len), len);
	strBuf.ReleaseBuffer();
	*bstrText = CComBSTR(strBuf).Copy();
}


void CMainFrame::ApiSetAddressText(BSTR bstrText)
{
	CString strText = bstrText;
	CEdit	edit	= m_AddressBar.GetEditCtrl();

	edit.SendMessage(WM_CHAR, 'P');
	edit.SetWindowText(strText);
}


LRESULT CMainFrame::ApiGetExtendedTabState(int nIndex)
{
	HWND hWndChild = m_MDITab.GetTabHwnd(nIndex);

	if ( !::IsWindow(hWndChild) )
		return 0x80000000;

	return ::SendMessage(hWndChild, WM_GET_EXTENDED_TABSTYLE, 0, 0);
}


void CMainFrame::ApiSetExtendedTabState(int nIndex, long nState)
{
	HWND hWndChild = m_MDITab.GetTabHwnd(nIndex);

	if ( !::IsWindow(hWndChild) )
		return;

	::SendMessage(hWndChild, WM_SET_EXTENDED_TABSTYLE, (WPARAM) nState, 0);
}


LRESULT CMainFrame::ApiGetKeyState(int nKey)
{
	//return (::GetAsyncKeyState(nKey) & 0x80000000) != 0;		//+++ ꂾƁAXNvgŕsł邱Ƃ邩ȂŁAԌ^̂قɍ킹.
	return (::GetAsyncKeyState(nKey) & 0x80000000);
}


long CMainFrame::ApiGetProfileInt(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, int nDefault)
{
	CString 	strFile    = bstrFile;
	CString 	strSection = bstrSection;
	CString 	strKey	   = bstrKey;
	CIniFileI	pr(strFile, strSection);
	return (long)pr.GetValue( strKey, nDefault );
}


void CMainFrame::ApiWriteProfileInt(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, int nValue)
{
	CString 	strFile    = bstrFile;
	CString 	strSection = bstrSection;
	CString 	strKey	   = bstrKey;
	CIniFileO	pr(strFile, strSection);
	pr.SetValue(nValue, strKey);
	//x pr.Close(); 	//+++
}


void CMainFrame::ApiGetProfileString(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, BSTR bstrDefault, /*[out, retval]*/ BSTR *bstrText)
{
	CString 	strFile 	= bstrFile;
	CString 	strSection	= bstrSection;
	CString 	strKey		= bstrKey;
	CString 	strDefault	= bstrDefault;
	CIniFileI	pr(strFile, strSection);
	CString 	strBuf		= pr.GetString(strKey, strDefault, 0xFFFFFFFF); //+++ size=0xFFFFFFFF̏ꍇ̓obt@TCYgŎ擾.
	*bstrText = CComBSTR(strBuf).Copy();
}


void CMainFrame::ApiWriteProfileString(BSTR bstrFile, BSTR bstrSection, BSTR bstrKey, BSTR bstrText)
{
	CString 		strFile    = bstrFile;
	CString 		strSection = bstrSection;
	CString 		strKey	   = bstrKey;
	CString 		strText    = bstrText;
	CIniFileO	pr(strFile, strSection);
	pr.SetValue( strText, strKey );
}


void CMainFrame::ApiGetScriptFolder( /*[out, retval]*/ BSTR *bstrFolder)
{
	ATLASSERT(bstrFolder != 0);
	CString 	strBuf = GetExeDirectory() + _T("Script\\");
	if (::GetFileAttributes(strBuf) == 0xFFFFFFFF)
		strBuf.Empty();

	*bstrFolder = CComBSTR(strBuf).Copy();
}


void CMainFrame::ApiGetCSSFolder( /*[out, retval]*/ BSTR *bstrFolder)
{
	ATLASSERT(bstrFolder != 0);
	CString 	strBuf = GetExeDirectory() + _T("CSS\\");
	if (::GetFileAttributes(strBuf) == 0xFFFFFFFF)
		strBuf.Empty();

	*bstrFolder = CComBSTR(strBuf).Copy();
}


void CMainFrame::ApiGetBaseFolder( /*[out, retval]*/ BSTR *bstrFolder)
{
	ATLASSERT(bstrFolder != 0);
	CString 	strBuf = GetExeDirectory();
	if (::GetFileAttributes(strBuf) == 0xFFFFFFFF)
		strBuf.Empty();

	*bstrFolder = CComBSTR(strBuf).Copy();
}


void CMainFrame::ApiGetExePath( /*[out, retval]*/ BSTR *bstrPath)
{
	ATLASSERT(bstrPath != 0);
	TCHAR Buf[MAX_PATH];
	::GetModuleFileName(_Module.GetModuleInstance(), Buf, MAX_PATH);
	*bstrPath = CComBSTR(Buf).Copy();
}


void CMainFrame::ApiSetStyleSheet(int nIndex, BSTR bstrStyleSheet, BOOL bOff)
{
	HWND		 hWndChild = m_MDITab.GetTabHwnd(nIndex);

	if ( !::IsWindow(hWndChild) )
		return;

	CChildFrame *pChild    = GetChildFrame(hWndChild);
	if (pChild == NULL)
		return;

	CString 	 strStylePath(bstrStyleSheet);
	CString 	 strStyleTitle;

	if ( bOff || strStylePath.IsEmpty() ) {
		// Off or Default
	} else {
		// Set New StyleSheet
		strStyleTitle = strStylePath.Mid(strStylePath.ReverseFind('\\') + 1);
	}

	pChild->StyleSheet(strStyleTitle, bOff, strStylePath);
}


//IAPI3
void CMainFrame::ApiSaveGroup(BSTR bstrGroupFile)
{
	CString strFile = bstrGroupFile;

	_SaveGroupOption(strFile);
}


void CMainFrame::ApiLoadGroup(BSTR bstrGroupFile, BOOL bClose)
{
	CString strFile = bstrGroupFile;

	_LoadGroupOption(strFile, bClose != 0/*? true : false*/);
}


//private:
struct CMainFrame::_ExtendProfileInfo {
	/*const*/LPCTSTR	lpstrIniPath;
	/*const*/LPCTSTR	lpstrSection;
	BOOL			  	bGroup;
};


//public:
int CMainFrame::ApiNewWindow3(BSTR bstrURL, BOOL bActive, long ExStyle, void *pExInfo)
{
	CString 	 strURL   = bstrURL;

	int 		 nCmdShow = bActive ? -1 : SW_SHOWNOACTIVATE;

	if (m_MDITab.GetItemCount() == 0)
		nCmdShow = -1;

	CChildFrame *pChild   = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar);

	if (pChild == NULL)
		return -1;

	pChild->ActivateFrame(nCmdShow);

	if ( strURL.IsEmpty() )
		strURL = _T("about:blank");

	if (*(int *) pExInfo) {
		_ExtendProfileInfo *_pExInfo   = (_ExtendProfileInfo *) pExInfo;
		CString 			strPath    = _pExInfo->lpstrIniPath;
		CString 			strSection = _pExInfo->lpstrSection;
		try {
			_Load_OptionalData(pChild, strPath, strSection);
		} catch (...) {
			ErrorLogPrintf("ApiNewWindow3");
			MessageBox( _T("OG[܂B(In NewWindow3 Function)\n"
						   "Ŝ߃vOċNĂB") );
		}

		if (_pExInfo->bGroup) {
			pChild->view().m_ViewOption._GetProfile(strPath, strSection, !CMainOption::s_bTabMode);
		} else {
			pChild->OnSetExtendedTabStyle(ExStyle | CChildFrame::FLAG_SE_NOREFRESH);
		}
	} else {
		pChild->OnSetExtendedTabStyle(ExStyle | CChildFrame::FLAG_SE_NOREFRESH);
	}

	pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon
	pChild->Navigate2(strURL);
pChild->ForceMessageLoop();								//+++ ... łɕsv낤Ƃ肠c....
	return m_MDITab.GetTabIndex(pChild->m_hWnd);
}


long CMainFrame::ApiAddGroupItem(BSTR bstrGroupFile, int nIndex)
{
	HWND		 hWndChild = m_MDITab.GetTabHwnd(nIndex);

	if ( !::IsWindow(hWndChild) )
		return -1;

	CChildFrame *pChild    = GetChildFrame(hWndChild);

	if (pChild == NULL)
		return -1;

	return pChild->_AddGroupOption(bstrGroupFile);
}


long CMainFrame::ApiDeleteGroupItem(BSTR bstrGroupFile, int nIndex)
{
	CString 		strGroupFile = bstrGroupFile;
	{
		CString 	strSection;
		strSection.Format(_T("Window%d"), nIndex);
		CIniFileO	pr(strGroupFile, strSection);
		bool		bRet = pr.DeleteSection();
		pr.Close();
		if (!bRet) {
			MessageBox("Error1: ZNV̍폜Ɏs܂B");
			return 0;
		}
	}

	std::list<CString>	buf;
	bool bRet = FileReadString(strGroupFile, &buf);
	if (!bRet) {
		MessageBox("Error2: t@C̓ǂݍ݂Ɏs܂B");
		return 0;
	}

	std::list<CString>::iterator str;

	for (str = buf.begin(); str != buf.end(); ++str) {
		CString strCheck = str->Left(7);
		strCheck.MakeUpper();

		if ( strCheck == _T("[WINDOW") ) {
			int nSecIndex = atoi( str->Mid(7, str->GetLength() - 7 - 1) );
			if (nSecIndex > nIndex) {
				str->Format("[Window%d]", nSecIndex - 1);
			}
		}
	}

	bRet = FileWriteString(strGroupFile, &buf);
	if (!bRet) {
		MessageBox("Error3: t@C݂̏Ɏs܂B");
		return 0;
	}

	DWORD		dwCount = 0, dwActive = 0, dwMaximize = 0;
	CIniFileIO	pr( strGroupFile, _T("Header") );
	pr.QueryValue( dwCount, _T("Count") );
	if (dwCount) {
		dwCount--;
		pr.SetValue( dwCount, _T("Count") );
	}

	pr.QueryValue( dwActive, _T("active") );
	if (dwCount == 0)
		pr.DeleteValue( _T("active") );
	else if ( (int) dwActive > nIndex )
		pr.SetValue( dwActive - 1, _T("active") );

	pr.QueryValue( dwMaximize, _T("maximized") );

	if (dwCount == 0)
		pr.DeleteValue( _T("maximized") );
	else if ( (int) dwMaximize > nIndex )
		pr.SetValue( dwMaximize - 1, _T("maximized") );

	return 1;
}


//IAPI4
HWND CMainFrame::ApiGetHWND(long nType)
{
	if (nType == 0)
		return m_hWnd;
	return NULL;
}

