/**
 *	@file	MainFrame_OpenFile.cpp
 *	@brief	CMainFrame  t@CJ֌W̏.
 *	@note
 *		+++ MainFrame.cpp 番.
 */

#include "stdafx.h"
#include "MainFrame.h"
#include "dialog/OpenURLDialog.h"



bool CMainFrame::OnDDEOpenFile(const CString &strFileName)
{
	//dmfTRACE(_T("CMainFrame::OnDDEOpenFile(%s)\n"), strFileName);
  #if 1 //+++ gCԂ̕Ał̃oO΍.
	IfTrayRestoreWindow();							//+++ gCԂ畜.
	DWORD flags = DonutGetStdOpenFlag();
	OnUserOpenFile( strFileName, flags );
	if (CStartUpOption::s_dwActivate) {
		MtlSetForegroundWindow(m_hWnd);
	}
  #else
	OnUserOpenFile( strFileName, DonutGetStdOpenFlag() );
	if (CStartUpOption::s_dwActivate) {
		//+++ OnUserOpenFile()̎_ōő剻/tXN[ꍇ̑΍nCmdShownčl悤ɕύX.
		MtlSetForegroundWindow(m_hWnd, m_OnUserOpenFile_nCmdShow);	//+++ ͂nCmdShow͈ӖႤ̂ĂĂ悤ȋC...Ƃ܂킵.
	}
  #endif
	// UDT DGSTR ( added by dai
	return true;
}




//public:
// Message handlers
// alternates OpenFile
HWND CMainFrame::OnUserOpenFile(LPCTSTR lpszFile, DWORD openFlag)
{
	CString 	 strFile(lpszFile);

	MtlRemoveStringHeaderAndFooter(strFile);

	if ( MtlIsExt( strFile, _T(".url") ) ) {
		return OpenInternetShortcut(strFile, openFlag);
	}

	if (  !MtlIsProtocol( strFile, _T("http") )
	   && !MtlIsProtocol( strFile, _T("https") ) )
	{
		if ( MtlPreOpenFile(strFile) )
			return NULL;	// handled
	  #if 1	//+++	^uƂ
		if (m_MDITab.GetItemCount() > 0) {
			if (strFile.Find(':') < 0 && strFile.Left(1) != _T("/") && strFile.Left(1) != _T("\\")) {	// łɋ̓IȃpXłȂƂA
				HWND			hWndChild 	= m_MDITab.GetTabHwnd(m_MDITab.GetCurSel());
				CChildFrame*	pChild 		= GetChildFrame(hWndChild);
				if (pChild) {		// ANeBuy[W݂
					CString strBase  = pChild->GetLocationURL();
					CString str7     = strBase.Left(7);
					if (str7 == "file://") {	// file://΁A[Jł̃fBNgړ낤Ƃ݂Ȃ
						strFile = MakeFullPath( strBase, strFile );	// tpX
					}
				}
			}
		}
	  #endif
	}

	if (strFile.GetLength() > INTERNET_MAX_PATH_LENGTH)
		return NULL;

	if ( strFile == _T("javascript:location.reload()") )
		return NULL;

	// UH (JavaScript dont create window)
	CString 	 strJava = strFile.Left(11);
	strJava.MakeUpper();

	if ( strJava == _T("JAVASCRIPT:") )
		openFlag |= D_OPENFILE_NOCREATE;

	// dfg files
	if ( MtlIsExt( strFile, _T(".dfg") ) ) {
		if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOCLOSEDFG) )
			_LoadGroupOption(strFile, true);
		else
			_LoadGroupOption(strFile, false);

		return NULL;
	}

  #if 1 //+++	TC^}(about:blank̕sCŌăRgAEg...
		//+++	unDonut+AƋ@\ĂȂ悤?A킴킴KvȂȁA)
		//+++   ƋCς̂ŏt̎b蕜
	// minit(about:* pages)
	{
		CString strAbout = strFile.Left(6);
		if ( strAbout == _T("about:") && strFile != _T("about:blank") ) {
			HWND hWndAbout =  _OpenAboutFile(strFile);
			if (hWndAbout)
				return hWndAbout;
		}
	}
  #endif

	HWND	hWndActive = MDIGetActive();

	int 	nCmdShow   = _check_flag(D_OPENFILE_ACTIVATE, openFlag) ? -1 : SW_SHOWNOACTIVATE;
	if (hWndActive == NULL) {					// no window yet
		nCmdShow = -1;							// always default
	}

	if ( hWndActive != NULL && _check_flag(D_OPENFILE_NOCREATE, openFlag) ) {
		CWebBrowser2 browser = DonutGetIWebBrowser2(hWndActive);

		if ( !browser.IsBrowserNull() ) {
			browser.Navigate2(strFile);

			if ( !_check_flag(D_OPENFILE_NOSETFOCUS, openFlag) ) {
				// reset focus
				::SetFocus(NULL);
				MtlSendCommand(hWndActive, ID_VIEW_SETFOCUS);
			}

			return NULL;
			//return hWndActive;
		}
	}

 	//+++
	//x if (CMainOption::s_dwMainExtendedStyle & (/*MAIN_EX_NOACTIVATE_NEWWIN|*/MAIN_EX_NEWWINDOW))
	{
		CChildFrame* pChild 	  = CChildFrame::NewWindow(m_hWndMDIClient, m_MDITab, m_AddressBar, false/*true*/);
		if (pChild == NULL)
			return NULL;

		if ( !strFile.IsEmpty() ) {
			pChild->SetWaitBeforeNavigate2Flag();			//+++ ABeforeNavigate2()s܂ł̊ԃAhXo[XVȂ悤ɂtOon... sv낤...
			m_OnUserOpenFile_nCmdShow = pChild->ActivateFrame(nCmdShow);
			pChild->Navigate2(strFile);
pChild->ForceMessageLoop(); 		//+++ ȀŃbZ[W΂. sv̂͂AĂȂ̂ȂAÔߎcĂ...
		} else {
			m_OnUserOpenFile_nCmdShow = pChild->ActivateFrame(nCmdShow);
		}

		if ( !_check_flag(D_OPENFILE_NOSETFOCUS, openFlag) ) {
			if (MDIGetActive() == pChild->m_hWnd) { // a new window activated, so automatically set focus
				// reset focus
				::SetFocus(NULL);
				MtlSendCommand(pChild->m_hWnd, ID_VIEW_SETFOCUS);
			} else {
				// It's reasonable not to touch a current focus.
			}
		}

		return pChild->m_hWnd;
	}
}



LRESULT CMainFrame::OnOpenWithExProp(_EXPROP_ARGS *pArgs)
{
	if (!pArgs)
		return 0;

	HWND		 hWndNew = OpenUrlWithExProp(pArgs->strUrl, pArgs->dwOpenFlag, pArgs->strIniFile, pArgs->strSection);
	if (!hWndNew)
		hWndNew = MDIGetActive();

	CChildFrame *pChild  = GetChildFrame(hWndNew);

	if (pChild) {
		// IvV擾
		DWORD		dwStatus;
		{
			CIniFileI pr( g_szIniFileName, _T("Search") );
			dwStatus  = pr.GetValue( _T("Status"), 0 );
		}

		CString 	str 	 = pArgs->strSearchWord;

		// uSp𔼊pɒuv`FbNĂϊĎqEBhEɕnB
		if (dwStatus & STS_TEXT_FILTER)
			m_SearchBar.FilterString(str);

	  	//+++ qɌݒ𔽉f (֐)
	   #if 1 //defined USE_UNDONUT_G_SRC
		if (dwStatus & STS_AUTOHILIGHT)
			pChild->SetSearchWordAutoHilight( str, 1 );
	   #else
		pChild->SetSearchWordAutoHilight( str, (dwStatus & STS_AUTOHILIGHT) != 0 );
	   #endif
	}

	return (LRESULT) hWndNew;
}


HWND CMainFrame::OpenInternetShortcut(CString strUrlFile, DWORD dwOpenFlag)
{
	CString strUrl = strUrlFile;

	if ( !MTL::ParseInternetShortcutFile(strUrl) )
		return NULL;

	return OpenUrlWithExProp(strUrl, dwOpenFlag, strUrlFile);
}


HWND CMainFrame::OpenUrlWithExProp(CString strUrl, DWORD dwOpenFlag, DWORD dwExProp)
{
	if ( _check_flag(D_OPENFILE_NOCREATE, dwOpenFlag) ) {
		return OpenExPropertyActive(strUrl, dwExProp, dwOpenFlag);		//̃^uŊJ
	} else {
		return OpenExPropertyNew(strUrl, dwExProp, dwOpenFlag); 		//VKɊJ
	}
}


HWND CMainFrame::OpenUrlWithExProp(CString strUrl, DWORD dwOpenFlag, CString strIniFile, CString strSection /*= DONUT_SECTION*/)
{
	DWORD dwExProp;

	if ( CExProperty::CheckExPropertyFlag(dwExProp, strIniFile, strSection) ) {
		if ( _check_flag(D_OPENFILE_NOCREATE, dwOpenFlag) ) {
			return OpenExPropertyActive(strUrl, dwExProp, dwOpenFlag);	//̃^uŊJ
		} else {
			return OpenExPropertyNew(strUrl, dwExProp, dwOpenFlag); 	//VKɊJ
		}
	} else {
		return OpenExPropertyNot(strUrl, dwOpenFlag);					//WIvVŊJ
	}
}


//^uɃirQ[ĝɊgݒKp
HWND CMainFrame::OpenExPropertyActive(CString &strUrl, DWORD dwExProp, DWORD dwOpenFlag)
{
	dwOpenFlag |= D_OPENFILE_NOCREATE;

	//ANeBuȃ^uirQ[gbNĂ邩mF
	HWND		 hWndActive = MDIGetActive();

	if ( ::IsWindow(hWndActive) ) {
		CChildFrame *pChild = GetChildFrame(hWndActive);

		if (pChild) {
			DWORD dwExFlag = pChild->view().m_ViewOption.m_dwExStyle;

			if (dwExFlag & DVS_EX_OPENNEWWIN)
				return OpenExPropertyNew(strUrl, dwExProp, dwOpenFlag);
		}
	}

	//擾URLANeBuȃ^uŊJiWɔCj
	BOOL		 bOpened	= FALSE;
	HWND		 hWndNew	= OnUserOpenFile(strUrl, dwOpenFlag);

	if (hWndNew && !hWndActive) {
		hWndActive = hWndNew;											//EBhÊŐVKɊJ
		bOpened    = TRUE;
	}

	//gvpeBKp
	CChildFrame *pChild 	= GetChildFrame(hWndActive);

	if (!pChild)
		return NULL;

	CExProperty  ExProp(CDLControlOption::s_dwDLControlFlags, CDLControlOption::s_dwExtendedStyleFlags, 0, dwExProp);

	pChild->view().PutDLControlFlags( ExProp.GetDLControlFlags() );
	pChild->SetViewExStyle(ExProp.GetExtendedStyleFlags(), TRUE);
	pChild->view().m_ViewOption.SetAutoRefreshStyle( ExProp.GetAutoRefreshFlag() );

	if (bOpened)
		return hWndActive;

	return NULL;
}


//VK^uĴgݒKp
HWND CMainFrame::OpenExPropertyNew(CString &strUrl, DWORD dwExProp, DWORD dwOpenFlag)
{
	dwOpenFlag &= ~D_OPENFILE_NOCREATE;

	//URLŐVK^uJ
	HWND		 hWndNew = OnUserOpenFile(strUrl, dwOpenFlag);

	if ( !::IsWindow(hWndNew) )
		return NULL;

	//gvpeBKp
	CChildFrame *pChild  = GetChildFrame(hWndNew);

	if (!pChild)
		return NULL;

	CExProperty  ExProp(CDLControlOption::s_dwDLControlFlags, CDLControlOption::s_dwExtendedStyleFlags, 0, dwExProp);

	pChild->view().PutDLControlFlags( ExProp.GetDLControlFlags() );
	pChild->SetViewExStyle(ExProp.GetExtendedStyleFlags(), TRUE);
	pChild->view().m_ViewOption.SetAutoRefreshStyle( ExProp.GetAutoRefreshFlag() );

	return hWndNew;
}


//^uĴAW̐ݒKp
HWND CMainFrame::OpenExPropertyNot(CString &strUrl, DWORD dwOpenFlag)
{
	//ANeBuȃ^uirQ[gbNĂ邩mF
	HWND hWndActive = MDIGetActive();

	if ( ::IsWindow(hWndActive) ) {
		CChildFrame *pChild = GetChildFrame(hWndActive);

		if (pChild) {
			DWORD dwExFlag = pChild->view().m_ViewOption.m_dwExStyle;

			if (dwExFlag & DVS_EX_OPENNEWWIN)
				dwOpenFlag &= ~D_OPENFILE_NOCREATE; 			//VK^uŊJ悤
		}
	}

	//擾URLJ
	HWND hWndNew	= OnUserOpenFile(strUrl, dwOpenFlag);

	if (hWndNew) {
		//VKɊJ^uȂ̂ŉȂĂ悢
		return hWndNew;
	} else {
		//IvVŴ̂ŏ㏑
		CChildFrame *pChild = GetChildFrame( MDIGetActive() );

		if (!pChild)
			return NULL;

		pChild->view().PutDLControlFlags(CDLControlOption::s_dwDLControlFlags);
		pChild->SetViewExStyle(CDLControlOption::s_dwExtendedStyleFlags, TRUE);
		pChild->view().m_ViewOption.SetAutoRefreshStyle(0);
	}

	return NULL;
}



LRESULT CMainFrame::OnFileRecent(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	// get file name from the MRU list
	if (ID_FILE_MRU_FIRST <= wID && wID <= ID_FILE_MRU_LAST)						//͈IDV͈ID֕ϊ
		wID = wID - ID_FILE_MRU_FIRST + ID_RECENTDOCUMENT_FIRST;

	CRecentDocumentListFixed::RecentDocEntry Entry;

	if ( CMainOption::s_pMru->GetFromList(wID, &Entry) ) {
		DWORD dwOpenFlag = DonutGetStdOpenCreateFlag(); /*DonutGetStdOpenFlag()*/	// Force New Window // UDT DGSTR
		HWND  hWndNew	 = OnUserOpenFile(Entry.szDocName, dwOpenFlag);

		if ( ::IsWindow(hWndNew) ) {
			if (CMainOption::s_bTravelLogClose) {
				CChildFrame *pChild = GetChildFrame(hWndNew);

				if (pChild) {
					_Load_OptionalData2(pChild, Entry.arrFore, Entry.arrBack);
				}
			}
		}

		CMainOption::s_pMru->RemoveFromList(wID);									// UDT DGSTR
	} else {
		::MessageBeep(MB_ICONERROR);
	}

	return 0;
}



//+++ FNŁAʂ̃vOtŋNꂽꍇ́Aɂ邪A
//+++       ̊O̒ǉ\DDEoRōs悤ŁAɂ邱Ƃ͂قƂǂȂ...?
void CMainFrame::OnNewInstance(ATOM nAtom)			// WM_NEWINSTANCE
{
	enum { NAME_LEN = 0x4000 };
	TCHAR szBuff[NAME_LEN+2];

	if (::GlobalGetAtomName(nAtom, szBuff, NAME_LEN) != 0) {
		//dmfTRACE(_T("CMainFrame::OnNewInstance: %s\n"), szBuff);
		OnUserOpenFile( szBuff, DonutGetStdOpenFlag() );
		::GlobalDeleteAtom(nAtom);
	}

	if ( !(CMainOption::s_dwMainExtendedStyle & MAIN_EX_NOACTIVATE) ) {
		MtlSetForegroundWindow(m_hWnd); 	//EChEANeBuɂ
		IfTrayRestoreWindow();				//+++ gCԂ畜.
		if (m_bOldMaximized == 0 && m_bFullScreen == 0) //+++
			ShowWindow_Restore(1);			//ShowWindow(SW_RESTORE);	//+++ TCY߂.
	}
}



////////////////////////////////////////////////////////////////////////////////
//t@Cj[
//@R}hnh
////////////////////////////////////////////////////////////////////////////////
////VK쐬

//|[y[W
void CMainFrame::OnFileNewHome(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	HWND hWndChild = OnUserOpenFile( NULL, DonutGetStdOpenActivateFlag() );

	if (hWndChild) {
		CWebBrowser2 browser = DonutGetIWebBrowser2(hWndChild);

		if (browser.m_spBrowser != NULL)
			browser.GoHome();
	}
}


//݂̃y[W
void CMainFrame::OnFileNewCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	HWND hWndActive = MDIGetActive();

	if (hWndActive) {
		CWebBrowser2 browser = DonutGetIWebBrowser2(hWndActive);

		if (browser.m_spBrowser != NULL) {
			CString strURL = browser.GetLocationURL();

			if ( !strURL.IsEmpty() )
				OnUserOpenFile( strURL, DonutGetStdOpenActivateFlag() );
		}
	}
}


LRESULT CMainFrame::OnFileNew(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	if (CFileNewOption::s_dwFlags == FILENEW_BLANK)
		OnFileNewBlank(0, 0, 0);
	else if (CFileNewOption::s_dwFlags == FILENEW_COPY) {
		if (MDIGetActive() != NULL)
			SendMessage(WM_COMMAND, MAKEWPARAM(ID_FILE_NEW_COPY, 0), 0);
		else
			OnFileNewBlank(0, 0, 0);
	} else if (CFileNewOption::s_dwFlags == FILENEW_HOME)
		OnFileNewHome(0, 0, 0);
	else
		ATLASSERT(FALSE);

	return 0;
}


//󔒃y[W
void CMainFrame::OnFileNewBlank(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	OnUserOpenFile( _T("about:blank"), DonutGetStdOpenActivateFlag() );
	SendMessage(WM_COMMAND, ID_SETFOCUS_ADDRESSBAR, 0);
}


//Nbv{[h
void CMainFrame::OnFileNewClipBoard(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	CString strText = MtlGetClipboardText();

	if ( strText.IsEmpty() )
		return;

	OnUserOpenFile( strText, DonutGetStdOpenActivateFlag() );
}


//Default.dfg
// UDT DGSTR
LRESULT CMainFrame::OnFileOpenDef(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	CString 	strPath = GetExeDirectory() + _T("Default.dfg");
	ATLTRACE2( atlTraceGeneral, 4, _T("CMainFrame::OnFileOpenDef\n") );
	OnUserOpenFile( strPath, DonutGetStdOpenCreateFlag() );
	return 0;
}
// ENDE



void CMainFrame::OnFileNewClipBoard2(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
{
	CString strText = MtlGetClipboardText();

	if ( strText.IsEmpty() )
		return;

	OnUserOpenFile( strText, DonutGetStdOpenFlag() );	// allow the option
}



LRESULT CMainFrame::OnFileOpen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	//dmfTRACE( _T("CMainFrame::OnFileOpen\n") );
	COpenURLDlg dlg;

	if ( dlg.DoModal() == IDOK && !dlg.m_strEdit.IsEmpty() ) {
		OnUserOpenFile( dlg.m_strEdit, DonutGetStdOpenFlag() );
	}

	return 0;
}



/// undonut ̔zzTCgJ
LRESULT CMainFrame::OnJumpToWebSite(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	//CString strSite = _T("http://www5.ocn.ne.jp/~minute/tab/"); //unDonutÂ
	//CString strSite = _T("http://undonut.sakura.ne.jp/"); // unDonutV
	//CString strSite = _T("http://tekito.genin.jp/undonut+.html"); //unDonut+
	CString strSite = _T("http://ichounonakano.sakura.ne.jp/64/undonut/"); //unDonut+mod.

	OnUserOpenFile( strSite, DonutGetStdOpenFlag() );
	return 0;
}


///+++ .exêtH_J
LRESULT CMainFrame::OnOpenExeDir(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	CString progDir = GetExeDirectory();
	ShellExecute(NULL, _T("open"), progDir, progDir, NULL, SW_SHOW);
	return 0;
}



#if 1	//+++ saitamap̂Ot@CǍɂĔėp.
HWND CMainFrame::_OpenAboutFile(CString strFile)
{
  #if 0	//+++ unDonut.ini [ETC] SAITAMA=1`ĂȂꍇ͋A
	{
		CIniFileI pr( g_szIniFileName, _T("ETC") );
		DWORD	  dwFlag = pr.GetValue(_T("SAITAMA"));
		if (dwFlag == 0)
			return 0;
	}
  #endif

	if (strFile.Left(6) != _T("about:"))
		return NULL;
	strFile     = strFile.Mid(6);		// about:
	bool  bWarn = (strFile == "warning");
	if (bWarn == 0) {
		strFile     = GetFullPath_ForExe( "help\\about\\" + strFile );	//
		if (IsExistFile(strFile) == 0)	//t@CȂ炩
			return NULL;
	}
	HWND					hWndChild = OnUserOpenFile( _T("about:blank"), DonutGetStdOpenFlag() );
	if ( !::IsWindow(hWndChild) )
		return NULL;

	CChildFrame *			pChild	  = GetChildFrame(hWndChild);
	if (!pChild)
		return hWndChild;

	CComPtr<IHTMLDocument2> pDoc;
	HRESULT 				hr;
	int 					ct		  = 0;

	while (1) {
		hr = pChild->m_spBrowser->get_Document( (IDispatch **) &pDoc );
		if (SUCCEEDED(hr) && pDoc) {
			break;
		}
		Sleep(100);

		ct++;
		if (ct > 50)
			return hWndChild;
	}

	CString		strText;
	if (bWarn) {	//+++ x̂Ƃ́A肻[ǂ
		HRSRC		hRes	  = ::FindResource(_Module.GetModuleInstance(), MAKEINTRESOURCE(IDR_TEXT_WARNING/*IDR_TEXT_SAITAMA*/), _T("TEXT") );
		HGLOBAL 	hMem	  = ::LoadResource(_Module.GetModuleInstance(), hRes);
		LPTSTR		lpstr	  = (LPTSTR) ::LockResource(hMem);
		strText   = CString(lpstr);
	} else {		//+++ ʏ help/about/̃t@Cǂݍ
		strText	  = FileLoadTextString( strFile );
	}

	DWORD		nSize	  = strText.GetLength() + 1;
	HGLOBAL 	hHTMLText = ::GlobalAlloc(GPTR, (nSize + 16/*C*/) * sizeof(TCHAR) );
	if (hHTMLText) {
		::CopyMemory(hHTMLText, LPCTSTR(strText), nSize * sizeof(TCHAR));
		{
			CComPtr<IStream> pStream;
			hr = ::CreateStreamOnHGlobal(hHTMLText, TRUE, &pStream);
			if ( SUCCEEDED(hr) ) {
				// Call the helper function to load the browser from the stream.
				LoadWebBrowserFromStream( pChild->m_spBrowser , pStream  );
			}
		}
	  #if 0	//+++ ǂ CreateStreamOnHGlobal̑TRUEȂ炻ŊJĂ悤Ȃ̂ŁA͕sv̂悤(win64ł̓nO)
		::GlobalFree( hHTMLText );
	  #endif
	}

	/*SAFEARRAY *psfArray;
	   VARIANT *pparam;
	   psfArray = SafeArrayCreateVector(VT_VARIANT, 0, 1);
	   if(psfArray){
		hr = SafeArrayAccessData(psfArray,(LPVOID*) & pparam);
		pparam->vt = VT_BSTR;
		pparam->bstrVal = bstrSaitama;
		hr = SafeArrayUnaccessData(psfArray);
		hr = pDoc->write(psfArray);
		SafeArrayDestroy(psfArray);
	   }*/

	//m_AddressBar.GetEditCtrl().SetWindowText(strFile);
	//int index = m_MDITab.GetTabIndex(hWndChild);
	//m_MDITab.SetItemText(index,strFile);
	return hWndChild;
}
#endif
