/**
 *	@file	MainFrame_PreTrnMsg.cpp
 *	@brief	CMainFrame  PreTranslateMessage֌W̏.
 *	@note
 *		+++ MainFrame.cpp 番.
 */

#include "stdafx.h"
#include "MainFrame.h"


#ifndef WM_XBUTTONDOWN
 #define WM_XBUTTONDOWN 				0x020B
 #define WM_XBUTTONUP					0x020C
 #define GET_KEYSTATE_WPARAM(wParam)	( LOWORD(wParam) )
 #define GET_XBUTTON_WPARAM(wParam) 	( HIWORD(wParam) )
 #define MK_XBUTTON1					0x0020
 #define MK_XBUTTON2					0x0040
 #define XBUTTON1						0x0001
 #define XBUTTON2						0x0002
#endif



//eEBhE(ɃL[)bZ[W]
BOOL CMainFrame::PreTranslateMessage(MSG *pMsg)
{
  #if 0	//+++ 
	if (g_pMainWnd && g_pMainWnd->m_hWnd) {
		static CString sav;
		CString tmp = MtlGetWindowText(g_pMainWnd->m_hWnd);
		//if (sav != tmp && tmp != "")
		{
			ErrorLogPrintf("%s\n", LPCTSTR(tmp));
			sav = tmp;
			MtlSetWindowText(g_pMainWnd->m_hWnd, tmp+"@");
		}
	}
  #endif

	//R}ho[(j[)
	if ( m_CmdBar.PreTranslateMessage(pMsg) )
		return TRUE;

	//AhXo[
	BYTE ptFlag 	= m_AddressBar.PreTranslateMessage(pMsg);
	if (ptFlag == _MTL_TRANSLATE_HANDLE)
		return TRUE;
	else if (ptFlag == _MTL_TRANSLATE_WANT)
		return FALSE;

	//o[
	ptFlag = m_SearchBar.PreTranslateMessage(pMsg);
	if (ptFlag == _MTL_TRANSLATE_HANDLE)
		return TRUE;
	else if (ptFlag == _MTL_TRANSLATE_WANT)
		return FALSE;

	//GNXv[o[
	//if (m_ExplorerBar.PreTranslateMessage(pMsg)) return TRUE;
	ptFlag = m_ExplorerBar.PreTranslateMessage(pMsg);
	if (ptFlag == _MTL_TRANSLATE_HANDLE)
		return TRUE;
	else if (ptFlag == _MTL_TRANSLATE_WANT)
		return FALSE;

  #if 1
	//+++ AhXo[orT[`o[ɃtH[JXĂ鎞Ȁŗ]vȂ(L[)Ȃ悤ɃK[hĂ݂
	int	bFocus = false;
	if (::IsWindow(m_AddressBar.m_hWnd))
		bFocus	|= (::GetFocus() == m_AddressBar.GetEditCtrl());
	if (::IsWindow(m_SearchBar.m_hWnd))
		bFocus	|= (::GetFocus() == m_SearchBar.GetEditCtrl());
  #endif

	// NX
	if (/*bFocus == 0 &&*/ baseClass::PreTranslateMessage(pMsg) )
		return TRUE;

	//ANeBuE`ChEEBhE
	HWND hWnd = MDIGetActive();

  #if 0	//+++ {^NbÑeXg
	if ( pMsg->message == WM_LBUTTONDOWN) {
		printf("%d,%d\n",pMsg->wParam, pMsg->lParam);
	}
  #endif

	// {^NbÑ`FbN
	if ( pMsg->message == WM_MBUTTONDOWN && hWnd != NULL && ::IsChild(hWnd, pMsg->hwnd) && OnMButtonHook(pMsg) )
		return TRUE;

	//}EXWFX`[
	if ( pMsg->message == WM_RBUTTONDOWN && OnRButtonHook(pMsg) )
		return TRUE;

	//TCh{^
	if (pMsg->message == WM_XBUTTONUP) {
		if ( OnXButtonUp( GET_KEYSTATE_WPARAM(pMsg->wParam), GET_XBUTTON_WPARAM(pMsg->wParam),
						 CPoint( GET_X_LPARAM(pMsg->lParam), GET_Y_LPARAM(pMsg->lParam) ) ) )
			return TRUE;
	}

	// GNXv[o[ŕ\
	if ( (CMainOption::s_dwExplorerBarStyle & MAIN_EXPLORER_AUTOSHOW) == MAIN_EXPLORER_AUTOSHOW )
		ExplorerBarAutoShow(pMsg);

	//BHO
	if (bFocus == 0 && TranslateMessageToBHO(pMsg) )											//+++ bFocus`FbN
		return TRUE;

	hWnd = MDIGetActive();	//+++ ӖȂƎvAÔߎ蒼...

	if (bFocus == 0 && hWnd != NULL && ::SendMessage(hWnd, WM_FORWARDMSG, 0, (LPARAM) pMsg) )	//+++ bFocus`FbN
		return TRUE;

	return FALSE; // IsDialogMessage(pMsg);
}


void CMainFrame::UpdateLayout(BOOL bResizeBars /*= TRUE*/)
{
	CRect	  rc;
	GetClientRect(&rc);

	if (bResizeBars) {
		_UpdateReBarPosition(rc);
	}

	{
		CClientDC dc(m_hWnd);
		_DoPaintReBarBorders(dc.m_hDC);
	}
	UpdateBarsPosition(rc, bResizeBars);
	_InflateReBarBordersRect(rc);

	if (m_hWndClient != NULL) {
		::SetWindowPos( m_hWndClient, NULL, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, SWP_NOZORDER | SWP_NOACTIVATE );
	}
}



BOOL CMainFrame::OnXButtonUp(WORD wKeys, WORD wButton, CPoint point)
{
	CString 	strKey;

	switch (wButton) {
	case XBUTTON1: strKey = _T("Side1"); break;
	case XBUTTON2: strKey = _T("Side2"); break;
	}

	DWORD		dwCommand = 0;
	{
		CIniFileI pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
		pr.QueryValue(dwCommand, strKey);
	}

	if (dwCommand == 0)
		return FALSE;

	::SendMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
	return TRUE;
}



void CMainFrame::ExplorerBarAutoShow(MSG *pMsg)
{
	if (pMsg->message != WM_MOUSEMOVE)
		return;

	if (pMsg->wParam != 0)
		return;

	if (  m_ExplorerBar.IsFavBarVisible()		== false
	   && m_ExplorerBar.IsClipboardBarVisible() == false
	   && m_ExplorerBar.IsPanelBarVisible() 	== false
	   && m_ExplorerBar.IsPluginBarVisible()	== false)
		return;

	CPoint point;
	::GetCursorPos(&point);

	CRect  rcWndCmd;
	::GetWindowRect(m_hWndToolBar, &rcWndCmd);

	if ( rcWndCmd.PtInRect(point) )
		return;

	ScreenToClient(&point);

	CRect  rcWnd;
	GetClientRect(&rcWnd);

	if (m_ExplorerBar.IsExplorerBarHidden() == false) {
		CRect rcWndExp;
		m_ExplorerBar.GetClientRect(&rcWndExp);
		rcWnd.left += rcWndExp.Width() + 5;

		if ( rcWnd.PtInRect(point) )
			m_wndSplit.SetSinglePaneMode(SPLIT_PANE_RIGHT);
	} else {
		if (point.x < 10 && point.x >= 0) {
			m_ExplorerBar.ShowBar(m_ExplorerBar.m_dwExStyle, true);
		}
	}
}


BOOL CMainFrame::OnMButtonHook(MSG* pMsg)
{
	DWORD	dwLinkOpenBtnM;
	{
		CIniFileI	 pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
		dwLinkOpenBtnM = pr.GetValue(_T("LinkOpenBtnM"), 0);
	}

	// {^ݒ肳ĂȂAI.
	if (dwLinkOpenBtnM == 0)
		return FALSE;
	//+++ FftHgł dwLinkOpenBtmM = IDM_FOLLOWLINKN
	// ATLASSERT(dwLinkOpenBtnM == IDM_FOLLOWLINKN);

  #if 0
	//+++ :̏́̕ADonutPDonutRAPT,unDonutłقǃ\[XɈႢ킯łȂ.
	::SendMessage(pMsg->hwnd, WM_LBUTTONDOWN, 0, pMsg->lParam); 	//+++ ܂Ȃ.
	int 	nTabCnt = m_MDITab.GetItemCount();						//+++ NNbNǂ̃`FbNp.
	::SendMessage(pMsg->hwnd, WM_COMMAND, dwLinkOpenBtnM, 0);		//+++ NVɂЂ炭
	if (m_MDITab.GetItemCount() != nTabCnt) 						//+++ ^uĂANNbN̂낤
		return TRUE;												//+++ trueԂĒ{^NbN̏Ƃɂ.
	::SendMessage(pMsg->hwnd, WM_LBUTTONUP, 0, pMsg->lParam);		//+++ NȊONbNꍇ܂Ȃ̍NbNIĂ.
	return FALSE;													//+++ falseԂƂŁAIER|[lgɃEB[NbN̏C.

	//+++ : 炭L̉EɏRĝ悤ȓz肵̂Ǝv.
	//		"܂Ȃ"ÁAWM_COMMAND+IDM_FOLLOWLINKN݂̂𑗂ꍇA
	//		ȂJ1NbN悤ŁA̒날킹Ƃ
	//		NbNƂɂĂ悤(...悭킩ȂǁAԂ).
	//		ANȊỎӏNbNƂ́A͈͑I̊JnƂċ@\Ă܂߁A
	//		̏ꍇ́AU{^NbNI鏈ĂB
	//
	//		́ANbNǂ̔ŁA^ǔIDM_FOLLOWLINKNɂ
	//		(ϓ)ǂĂ̂...
	//		~jbgȑO̊J҂̊ł͗L̂悤Aundonut++mod̊Jł́A
	//		N̗Lɂ炸̎_ł̓^uςȂ͗l... 
	//		FALSEԂɗANbNLZ̏JNbNƓlɍp
	//		܂AʓIɓy[WQJĂ܂AƂoOɉĂ܂Ă.
	//
	//		󋵓Iɂ::SendMessage(pMsg->hwnd, WM_COMMAND, dwLinkOpenBtnM, 0);̎s
	//		V^ułĂ畜AĂmANGXgsĂ߂Ă鏈
	//		ɕςĂ܂AƂƂɎvB
	//
	//		CChildFrameł o[ActivateFrame()̏̒Ń^uւ̒ǉ
	//		̂AWM_COMMAND+dwLinkOpenBtnMCChildFrameꍇA
	//		CChildFrame::OnNewWindow2() Ă΂Ã[głActivateFrame()͒ɂ͌Ă΂ꂸA
	//		ƂActivateFrame()Ă΂悤ɂĂB̏ԂOnNewWindow2͏ÎŁA
	//		SendMessageIĂ^u͕̐ςȂAƂ̏Ԃ́A
	//		\[XIɂ͓RɎv̂... (̂ւ̑؂donutPɂ̂ڂĂ)
	//
	//		ŁAActivateFrameƂŒNĂԂƂ CChildFrame::OnBeforeNavigate2() ŁA
	//		 MtlBrawser.hIWebBrowserEvents2Impl::OnBeforeNavigate2Ă΂Ă
	//		܂A܂ĂJł́ADonut\[XŖIɂ̊֐ĂłȂǁA
	//		SendMessageI܂łɂsAƂƂȂ̂낤.
	//		( ЂƂƁA OnNewWindow2ȊOChildFrameĂ\邩)
	//
	//		OS,IE,PSDK/ATL,WTL, unDonut ̂ǂ̏Ȃ̂낤A悭킩Ȃ
	//		(2007-11-23)
	//		ǂ AtlHost(Ex)łCreateControlLicEx ,Navigate2()܂elsecĂ̂
	//		܂͗lBelse폜璼. (2008-01-01)
  #else //+++ Nǂ̔ɃXe[^Xo[ɃN悪ݒ肳Ă邩ǂAp悤ɂ.
	HWND			hWnd	= MDIGetActive();
	if ( ::IsWindow(hWnd) == 0 )
		return FALSE;
	CChildFrame*	pChild	= GetChildFrame(hWnd);
	bool			bLink	= 0;
	if (pChild) {																//+++ J[\NĂstatusBarp̃bZ[W邱Ƃ𗘗p.
		const CString& str = pChild->strStatusBar();
		if (str.IsEmpty() == 0 && str != "y[W\܂")				//+++ N̂Ȃy[Wł"y[W\܂"ƂbZ[Wݒ肳Ă̂ŏO.
			bLink = true;
	}
	::SendMessage(pMsg->hwnd, WM_LBUTTONDOWN, 0, pMsg->lParam); 				//+++ ܂Ȃ.
	int 	nTabCnt = m_MDITab.GetItemCount();									//+++ NNbNǂ̃`FbNp.
	::SendMessage(pMsg->hwnd, WM_COMMAND, dwLinkOpenBtnM, 0);					//+++ NVɂЂ炭
	int 	nTabCnt2 = m_MDITab.GetItemCount();
	if (nTabCnt != nTabCnt2 || bLink)											//+++ NbZ[W邩A^uĂANNbNƂ.
		return TRUE;															//+++ trueԂĒ{^NbN̏Ƃɂ.
	::SendMessage(pMsg->hwnd, WM_LBUTTONUP, 0, pMsg->lParam);					//+++ NȊONbNꍇ܂Ȃ̍NbNIĂ.
	return FALSE;																//+++ falseԂƂŁAIER|[lgɃEB[NbN̏C.
  #endif
}


// Mouse Gesture
BOOL CMainFrame::OnRButtonHook(MSG *pMsg)
{
	HWND		hChildWnd = MDIGetActive();

	if (hChildWnd) {
		BOOL	bUsedMouseGesture = ::SendMessage(hChildWnd, WM_USER_USED_MOUSE_GESTURE, 0, 0) != 0;
		if (bUsedMouseGesture == FALSE)
			return FALSE;
	}

	::SetCapture(m_hWnd);

	CPoint		ptDown;
	ptDown.x = GET_X_LPARAM(pMsg->lParam);
	ptDown.y = GET_Y_LPARAM(pMsg->lParam);
	::ClientToScreen(pMsg->hwnd, &ptDown);

	CPoint		ptBefor   = ptDown;
	CPoint		ptUp	  = ptDown;
	int 		nAng1	  = -1;
	CString 	strMove;
	CString 	strMark1;
	CString 	strMark2;
	DWORD		dwTime	  = -1;
	HWND		hWndHist  = m_hWnd;
	HWND		hWnd	  = NULL;
	BOOL		bNoting   = TRUE;
	MSG 		msg;
	ZeroMemory(&msg, sizeof msg);

	do {
		if (::GetCapture() != hWndHist)
			break;

		if (m_hWnd != hWndHist)
			break;

		if (::GetMessage(&msg, NULL, 0, 0) == FALSE)
			continue;

		int 	nDiff		= 0;
		DWORD	dwCommand	= 0;
		BOOL	bNeedFresh	= FALSE,
				bBreak		= FALSE;

		switch (msg.message) {
		case WM_MOUSEWHEEL:
			dwCommand = GetMouseWheelCmd( (short) HIWORD(msg.wParam) );
			break;

		case WM_LBUTTONUP:
		case WM_MBUTTONUP:
			dwCommand = GetMouseButtonUpCmd(msg.message);
			break;

		case WM_XBUTTONUP:
			dwCommand = GetMouseButtonUpCmd( msg.message, GET_XBUTTON_WPARAM(msg.wParam) );
			break;

		case WM_MOUSEMOVE:
			ptUp.x	  = GET_X_LPARAM(msg.lParam);
			ptUp.y	  = GET_Y_LPARAM(msg.lParam);
			::ClientToScreen(msg.hwnd, &ptUp);

			nDiff	  = (int) ( sqrt( pow(float (ptBefor.x - ptUp.x), 2.0f) + pow(float (ptBefor.y - ptUp.y), 2.0f) ) );
			if (nDiff < 10)
				break;

			nAng1	  = (int) _GetAngle(ptBefor, ptUp);
			ptBefor   = ptUp;

			if		(nAng1 <  45 || nAng1 >  315)
				strMark1 = _T("");
			else if (nAng1 >= 45 && nAng1 <= 135)
				strMark1 = _T("");
			else if (nAng1 > 135 && nAng1 <  225)
				strMark1 = _T("");
			else if (nAng1 >= 225 && nAng1 <= 315)
				strMark1 = _T("");

			if (strMark1 == strMark2) {
				DWORD dwTimeNow = ::GetTickCount();

				if ( (dwTimeNow - dwTime) > 300 ) {
					strMark2 = _T("");
					dwTime	 = dwTimeNow;
				}
			}

			if (strMark1 != strMark2) {
				strMove += strMark1;
				strMark2 = strMark1;

				DWORD	dwCommand = 0;
				CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
				pr.QueryValue(dwCommand, strMove);
				pr.Close();
				CString strCmdName;

				if (dwCommand != 0) {
					CString strTemp;
					CToolTipManager::LoadToolTipText(dwCommand, strTemp);
					strCmdName.Format("[ %s ]", strTemp);
				}

				CString 	strMsg;
				strMsg.Format("WFX`[ : %s %s", strMove, strCmdName);
				::SetWindowText(m_hWndStatusBar, strMsg);
			}

			dwTime = ::GetTickCount();
			break;

		case WM_KEYDOWN:
			hWnd   = MDIGetActive();
			if (hWnd != NULL)
				SendMessage(hWnd, WM_FORWARDMSG, 0, (LPARAM) &msg);

			break;

		default:
			DispatchMessage(&msg);
			break;
		}

		switch (dwCommand) {
		case ID_FILE_CLOSE:
			hWnd	   = MDIGetActive();
			if (hWnd == NULL)
				break;

			::PostMessage(hWnd, WM_COMMAND, ID_FILE_CLOSE, 0);
			//::PostMessage(hWnd, WM_CLOSE, 0, 0);
			bNoting    = FALSE;
			bNeedFresh = TRUE;
			//goto NEXT;
			break;

		case ID_GET_OUT:				// ޔ
		case ID_VIEW_FULLSCREEN:		// S̕\
		case ID_VIEW_UP:				// 
		case ID_VIEW_BACK:				// Oɖ߂
		case ID_VIEW_FORWARD:			// ɐi
		case ID_VIEW_STOP_ALL:			// ׂĒ~
		case ID_VIEW_REFRESH_ALL:		// ׂčXV
		case ID_WINDOW_CLOSE_ALL:		// ׂĕ
		case ID_WINDOW_CLOSE_EXCEPT:	// ȊO
			::PostMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
			bNoting    = FALSE;
			bBreak	   = TRUE;
			break;

		case 0:
			break;

		default:
			::PostMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
			bNoting    = FALSE;
			bNeedFresh = TRUE;
			break;
		}

		if (bNeedFresh) {
			hWnd = MDIGetActive();
			if (hWnd)
				::RedrawWindow(hWnd, NULL, NULL, RDW_UPDATENOW);
		}

		if (!(GetAsyncKeyState(VK_RBUTTON) & 0x80000000) && msg.message != WM_RBUTTONUP) {
			MSG msgR;
			if (::PeekMessage(&msgR, NULL, 0, 0, PM_NOREMOVE) == 0) {
				break;
			}
		}
	} while (msg.message != WM_RBUTTONUP);

	::ReleaseCapture();

	if (bNoting) {
		ptUp.x = GET_X_LPARAM(msg.lParam);
		ptUp.y = GET_Y_LPARAM(msg.lParam);
		::ClientToScreen(msg.hwnd, &ptUp);

		::SetWindowText( m_hWndStatusBar, _T("") );

		DWORD dwCommand = 0;
		CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
		pr.QueryValue(dwCommand, strMove);
		pr.Close();

		if (dwCommand != 0) {
			::SendMessage(m_hWnd, WM_COMMAND, dwCommand, 0);
			bNoting = FALSE;
		} else if (dwCommand == -1)
			return TRUE;
	}

	if ( bNoting && strMove.IsEmpty() ) {
		::ScreenToClient(pMsg->hwnd, &ptUp);
		pMsg->lParam = MAKELONG(ptUp.x, ptUp.y);

		::PostMessage(pMsg->hwnd, WM_RBUTTONUP, pMsg->wParam, pMsg->lParam);
	}

	return !bNoting;
}


DWORD CMainFrame::GetMouseWheelCmd(short nWheel)
{
	CString 	strKey;
	if (nWheel > 0)
		strKey = _T("WHEEL_UP");
	else
		strKey = _T("WHEEL_DOWN");

	CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
	DWORD		dwCommand = pr.GetValue(strKey, 0);
	return dwCommand;
}


DWORD CMainFrame::GetMouseButtonUpCmd(UINT uMsg, UINT nXButton/* = 0*/)
{
	CString 	strKey;
	switch (uMsg) {
	case WM_LBUTTONUP:	strKey = _T("LButtonUp");				break;
	case WM_MBUTTONUP:	strKey = _T("MButtonUp");				break;
	case WM_XBUTTONUP:	strKey.Format("XButtonUp%d", nXButton); break;
	}

	CIniFileI	pr( _GetFilePath( _T("MouseEdit.ini") ), _T("MouseCtrl") );
	DWORD		dwCommand = pr.GetValue(strKey, 0);
	return dwCommand;
}



BOOL CMainFrame::TranslateMessageToBHO(MSG *pMsg)
{
	if (  (WM_KEYFIRST		 <= pMsg->message) && (pMsg->message <= WM_KEYLAST	)
	   || (WM_IME_SETCONTEXT <= pMsg->message) && (pMsg->message <= WM_IME_KEYUP) )
	{
		int nCount = CPluginManager::GetCount(PLT_TOOLBAR);

		for (int i = 0; i < nCount; i++) {
			if ( CPluginManager::Call_PreTranslateMessage(PLT_TOOLBAR, i, pMsg) )
				return TRUE;
		}
	}

	return FALSE;
}

