/**
 *	@file	aboutdlg.cpp
 *	@brief	o[W\_CAO
 */
#include "stdafx.h"
#include "aboutdlg.h"
#include "../MtlWin.h"
#include "../MtlMisc.h"
#include "../appconst.h"
#include "../DonutPFunc.h"


//gp閼OԂ̒`

using namespace WTL;


//ȉ
CAboutDlg::CAboutDlg()
	: m_wndEdit(this, 1)			//eLXg{bNXւ̃bZ[WALT_MSG_MAP(1)Ŏ󂯎
{
}



LRESULT CAboutDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL & /*bHandled*/)
{
	CenterWindow( GetParent() );	//_CAO͏ɒ\

	//xɏݒ
	CStatic label	   = GetDlgItem(IDC_STATIC_VERSION);
	CString strAppName = app::cnt_AppName;
	CString strAppVer  = app::cnt_AppVersion;
	MtlSetWindowText(label.m_hWnd, strAppName + " " + strAppVer);

	//eLXg{bNXɏݒ
	CEdit	edit	   = GetDlgItem(IDC_EDITINFO);
	MtlSetWindowText( edit.m_hWnd, GetEnvironInfo() );

	//eLXg{bNXẴbZ[Wł悤ɂ
	m_wndEdit.SubclassWindow(edit.m_hWnd);
	return TRUE;
}



LRESULT CAboutDlg::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
{
	//_CAO
	EndDialog(wID);
	return 0;
}



LRESULT CAboutDlg::OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL & /*bHandled*/)
{
	//eLXgSI
	CEdit  edit = GetDlgItem(IDC_EDITINFO);

	edit.SetSelAll();

	//j[\(Nbv{[hɃeLXgRs[邩ۂ)
	CMenu  menu;
	menu.CreatePopupMenu();
	menu.AppendMenu( 0, 1, _T("Nbv{[hɃRs[") );

	//ڂIꂽeLXgRs[
	CPoint pos;
	::GetCursorPos(&pos);
	int    nRet = menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_RETURNCMD | TPM_NONOTIFY,
									  pos.x, pos.y, m_hWnd);

	if (nRet == 1)
		MtlSetClipboardText(MtlGetWindowText(edit.m_hWnd), m_hWnd);

	return 0;
}



//OSʂłȂꍇ̕
#define UNKNOWNCODE _T("OS:unknown")



CString CAboutDlg::GetEnvironInfo()
{
	//ʂ̊擾
	CString strOSName	  = GetOSName(); //莸sUNKNOWNCODEԂ
	CString strVersion	  = GetVersion();
	CString strOSInfo	  = GetOSInfo();
	CString strIEVersion  = GetIEVersion();
	CString strUpdateInfo = GetUpdateInfo();

	//莸s̏
	if (strOSName != UNKNOWNCODE)
		strOSName = _T("Windows ") + strOSName;

	//eLXg{bNXɕ\
	CString strInfo;
	strInfo.Format(_T("%s %s\r\nOS : %s (%s) %s\r\nIE : %s%s\r\n"),
				   app::cnt_AppName, app::cnt_AppVersion, strOSName, strVersion, strOSInfo, strIEVersion, strUpdateInfo);

	return strInfo;
}



CString CAboutDlg::GetIEVersion()
{
	//WXgIẼo[W擾
	TCHAR	buf[MAX_PATH+2];
	DWORD	dwCount = MAX_PATH;
	CRegKey reg;

	memset(buf, 0, sizeof buf); //+++
	reg.Open( HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Internet Explorer") );
	RegKey_QueryStringValue(reg, _T("Version"), buf, &dwCount);
	reg.Close();

	return CString(buf);
}



CString CAboutDlg::GetUpdateInfo()
{
	//WXgWindows̃Abvf[g擾
	TCHAR	buf[MAX_PATH+2];
	DWORD	dwCount = MAX_PATH;
	CRegKey reg;

	memset(buf, 0, sizeof buf); //+++
	reg.Open( HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Internet Settings") );
	RegKey_QueryStringValue(reg, _T("MinorVersion"), buf, &dwCount);
	reg.Close();

	return CString(buf);
}



CString CAboutDlg::GetOSInfo()
{
	//OS̒ǉ擾
	OSVERSIONINFO osvi = { sizeof (OSVERSIONINFO) };

	::GetVersionEx(&osvi);

	if (osvi.szCSDVersion[1] != 'A' && osvi.szCSDVersion[1] != 'B' && osvi.szCSDVersion[1] != 'C') {
		return CString(osvi.szCSDVersion);
	} else {
		return CString();
	}
}



CString CAboutDlg::GetVersion()
{
	//OS̃o[WW[E}Ci[Erhio[̏ŕ\
	OSVERSIONINFO osvi = { sizeof (OSVERSIONINFO) };

	::GetVersionEx(&osvi);

	CString 	  strVersion;
	strVersion.Format(_T("%d.%d.%d"), osvi.dwMajorVersion,
					  osvi.dwMinorVersion,
					  osvi.dwBuildNumber & 0xffff);
	return strVersion;
}



CString CAboutDlg::GetOSName()
{
	//OS擾
	OSVERSIONINFO osvi = { sizeof (OSVERSIONINFO) };

	::GetVersionEx(&osvi);

	//o[Wɏ𕪂
	if (osvi.dwMajorVersion == 3) {
		return GetOSName_Version3(osvi);
	} else if (osvi.dwMajorVersion == 4) {
		return GetOSName_Version4(osvi);
	} else if (osvi.dwMajorVersion == 5) {
		return GetOSName_Version5(osvi);
	} else if (osvi.dwMajorVersion == 6) {
		return GetOSName_Version6(osvi);
	} else {
		return UNKNOWNCODE;
	}
}



CString CAboutDlg::GetOSName_Version3(OSVERSIONINFO &osvi)	//NT3.51
{
	if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if (osvi.dwMinorVersion == 51)
			return _T("NT 3.51");
		else
			return UNKNOWNCODE;
	} else {
		return UNKNOWNCODE;
	}
}



CString CAboutDlg::GetOSName_Version4(OSVERSIONINFO &osvi)	//95 98 Me NT4
{
	if (osvi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) {
		if (osvi.dwMinorVersion >= 90) {
			//Me
			return _T("Me");
		} else if (osvi.dwMinorVersion >= 10) {
			//98
			if (osvi.szCSDVersion[1] == 'A') {
				return _T("98 SE");
			} else {
				return _T("98");
			}
		} else if (osvi.dwMinorVersion >= 0) {
			//95
			if (osvi.szCSDVersion[1] == 'B' || osvi.szCSDVersion[1] == 'C') {
				return _T("95 OSR2");
			} else {
				return _T("95");
			}
		} else {
			return UNKNOWNCODE;
		}
	} else if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		//NT4
		if (osvi.dwMinorVersion == 0) {
			return _T("NT 4.0");
		} else {
			return UNKNOWNCODE;
		}
	} else {
		return UNKNOWNCODE;
	}
}



CString CAboutDlg::GetOSName_Version5(OSVERSIONINFO &osvi)	//2000 XP 2003Server
{
	if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
	  #if defined _WIN64
		if (osvi.dwMinorVersion >= 2) {
			return _T("Server 2003(x64)");
		} else if (osvi.dwMinorVersion == 1) {
			return _T("XP(x64)");
		} else {
			return _T("2000(x64)"); 						//Ȃ?
		}

	  #else
		if ( _IsWow64() ) {
			if (osvi.dwMinorVersion >= 2) {
				return _T("Server 2003(x64)");
			} else if (osvi.dwMinorVersion == 1) {
				return _T("XP(x64)");
			} else {
				return _T("2000(x64)"); 					//Ȃ?
			}
		} else {
			if (osvi.dwMinorVersion >= 2) {
				return _T("Server 2003");
			} else if (osvi.dwMinorVersion == 1) {
				return _T("XP");
			} else {
				return _T("2000");
			}
		}
	  #endif

	} else {
		return UNKNOWNCODE;
	}
}



CString CAboutDlg::GetOSName_Version6(OSVERSIONINFO &osvi)	//Vista
{
	if (osvi.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		if (osvi.dwMinorVersion == 0) {
		  #if defined _WIN64
			return _T("Vista(x64)");
		  #else
			if ( _IsWow64() )
				return _T("Vista(x64)");
			else
				return _T("Vista");
		  #endif

		} else {
			return UNKNOWNCODE;
		}
	} else {
		return UNKNOWNCODE;
	}
}
